/*
 *  This file is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  It is part of httppc, which is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <string.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netdb.h>
#include <stdlib.h>
#include <stdio.h>
#include "config.h"
#include "internal.h"

int
main(int argc, char *argv[])
{
#ifdef HAVE_GETADDRINFO
    struct addrinfo *addrinfo, hints;
    int err;

    if (argc != 3 && argc != 2)
    {
        printf("%s <host> [<service>]\n", argv[0]);
        exit(1);
    }
    
    memset(&hints, 0, sizeof(hints));
    hints.ai_family = PF_UNSPEC;
    hints.ai_flags = AI_CANONNAME;
    httppc__mode = MODE_VERBOSE;
    err = getaddrinfo(argv[1], argc == 3 ? argv[2] : 0, &hints, &addrinfo);
    if (err)
    {
        printf("error: %s\n", gai_strerror(err));
        exit(1);
    }

/*    log_addrinfo(addrinfo);*/
    freeaddrinfo(addrinfo);
    return 0;
#else // !HAVE_GETADDRINFO
    printf("error: getaddrinfo() is not implemented on this platform\n");
    return 1;
#endif // !HAVE_GETADDRINFO
}
