/*
 *  This file is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  It is part of httppc, which is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef HTTPPC__OPTIONS__H__
#define HTTPPC__OPTIONS__H__

#include "httppc.h"

struct net_entry
{
    unsigned network, mask;
};

struct options
{
    // system entries
    httppc_connect_t real_connect;
    httppc_gethostbyname_t real_gethostbyname;
    httppc_gethostbyname_r_t real_gethostbyname_r;
    httppc_gethostbyaddr_t real_gethostbyaddr;
    httppc_gethostbyaddr_r_t real_gethostbyaddr_r;
    httppc_socket_t real_socket;
    httppc_select_t real_select;
    httppc_poll_t real_poll;
#ifdef HAVE_GETADDRINFO
    httppc_getaddrinfo_t real_getaddrinfo;
#endif // HAVE_GETADDRINFO
    // proxy parameters
    char http_proxy[BUFF_LEN];
    unsigned short http_proxy_port;
    // extern DNS server to use
    char extern_dns[BUFF_LEN];
    // entries for local and external networks
    char extern_nets[MAX_NETS][BUFF_LEN], local_nets[MAX_NETS][BUFF_LEN];
    struct net_entry extern_ne[MAX_NETS], local_ne[MAX_NETS];
    int extern_lsz, local_lsz;
    // HTTP proxy authorization parameters
    char proxy_user[BUFF_LEN], proxy_pass[BUFF_LEN];
    // user agent
    char useragent[BUFF_LEN];
    // connect timeout
    int timeout;
    // proxy connection mode
    httppc_args conn_args;
};

#define in_nets_list    httppc__in_nets_list
#define init            httppc__init

struct in_addr;

int in_nets_list(struct in_addr t, struct net_entry *ne, int len);
void init(int *initialized, struct options *cfg);

#endif

