/*
 *  This file is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  It is part of httppc, which is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#include <sys/types.h>
#include <stdlib.h>
#include <stdio.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include "httppc.h"
#include "config.h"

#define BUFF_LEN    1024

int
main(int argc, char *argv[])
{
    struct hostent *hostinfo;

    if (argc != 2 && argc != 3)
    {
        printf("Usage: %s <host>\n", argv[0]);
        exit(1);
    }
    
    hostinfo = httppc_gethostbyname(argv[1], argc == 3 ? argv[2] : "128.9.176.32"); // isi.edu - default
    if (hostinfo)
    {
        struct in_addr **addrl = (struct in_addr **)hostinfo->h_addr_list;
        int n = 0;
        if (addrl)
            while (addrl[n])
            {
                const char *dot_name = inet_ntoa(*addrl[n++]);
                //printf("%s has address %s\n", hostinfo->h_name, dot_name);
                printf("%s has address %s\n", argv[1], dot_name);
            }
    } else
    {
        printf("Host %s not found: %s\n", argv[1], hstrerror(h_errno));
    }
    return 0;
}
