/*
 *  This file is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  It is part of httppc, which is
 *    Copyright (C) 2001 Alexey Klimkin <klimkin@mcst.ru>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software Foundation,
 *  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
 */

#ifndef _SYSPROTO_H_
#define _SYSPROTO_H_

// system prototypes
int connect(int sockfd, const struct sockaddr *serv_addr, socklen_t addrlen);

// Linux
#if defined(__GLIBC__)
# ifdef HAVE_GETHOSTBYNAME_R
int gethostbyname_r(const char *name, struct hostent *result_buf,
                    char *buf, size_t buflen,
                    struct hostent **result, int *h_errnop);
# endif // HAVE_GETHOSTBYNAME_R
# ifdef HAVE_GETHOSTBYADDR_R
int gethostbyaddr_r(GETHOSTBYADDR_R_FV_TYPE addr, socklen_t len, int type,
                    struct hostent *result_buf, char *buf, size_t buflen,
                    struct hostent **result, int *h_errnop);
# endif // HAVE_GETHOSTBYADDR_R
//
#else
# ifdef HAVE_GETHOSTBYNAME_R
struct hostent *gethostbyname_r(const char *name, struct hostent *result_buf,
                                char *buf, int buflen, int *h_errnop);
# endif // HAVE_GETHOSTBYNAME_R
# ifdef HAVE_GETHOSTBYADDR_R
struct hostent *gethostbyaddr_r(const char *addr, int len, int type,
                                struct hostent *result_buf,
                                char *buf, int buflen, int *h_errnop);
# endif // HAVE_GETHOSTBYADDR_R
#endif

struct hostent *gethostbyname(const char *name);

#if defined(__GLIBC__)
struct hostent *gethostbyaddr(GETHOSTBYADDR_FV_TYPE addr, socklen_t len,
                              int type);
#else // !__GLIBC__
struct hostent *gethostbyaddr(const char *addr, int len, int type);
#endif // !__GLIBC__

int socket(int domain, int type, int pnum);

#ifdef HAVE_GETADDRINFO
int getaddrinfo(const char *node, const char *service,
                const struct addrinfo *hints, struct addrinfo **res);
#endif // HAVE_GETADDRINFO

#endif
